                   Quarterdeck Technical Note

     Patching DESQview to support the Microsoft Ballpoint Mouse 
with the Microsoft mouse driver 8.00 (and above).  This patch 
works with DESQview 2.24 and above.     

      Background:  When attached to a mouse port, the Microsoft 
Ballpoint Mouse identifies itself as device type 2 when queried 
with INT 15 function C204. Before the Ballpoint Mouse, all mice 
identified themselves as device type 0 when queried with this 
call.  DESQview 2.41 (and earlier versions) handles this call 
instead of the system BIOS, and routinely returns device type 0. 
This causes the Microsoft mouse driver 8.00 to believe that a 
Ballpoint Mouse is not attached to the mouse port when DESQview 
is running.  Two symptoms of this condition: the COMPASS.EXE 
configuration program that ships with the Ballpoint Mouse refuses 
to run inside DESQview, posting an error message that a Ballpoint 
Mouse is not attached to the mouse port; and the DESQview diamond-
shaped mouse cursor persistently jumps toward the left of the 
screen when moved.

     This patch causes DESQview to support the Ballpoint mouse's 
response to this call. If you have a Ballpoint mouse hooked to 
your mouse port and the mouse cursor is behaving erratically 
inside of DESQview, or if COMPASS.EXE fails to run inside 
DESQview, then this patch may solve the problem.  This patch is 
unnecessary if the Ballpoint mouse is connected to a serial port.

     Drawbacks:  This patch will cause DESQview to stop working 
with port mice OTHER THAN the Ballpoint mouse if used with MS 
driver 8.00 or later.  It will not affect the way non-port mice 
work in DESQview.

       -------------------------------------------------

     1)  Make a copy of the DV.EXE file in your DV directory.  We 
are about to alter your current copy of DV.EXE; the copy you make 
will serve as a backup in case this operation fails.

          COPY C:\DV\DV.EXE C:\DV\DVOLD.EXE

     (If your DV.EXE is not located in the DV directory of the C: 
drive, change the path accordingly.)

     2)  Rename DV.EXE to X:
                
               REN C:\DV\DV.EXE X

     3)  Go to the DOS directory on the hard disk and type:

               DEBUG C:\DV\X

     (If your DV.EXE is not located in the QEMM directory of the 
C: drive, change the path accordingly.)

     Hit the Enter key; you should the the DEBUG prompt, which is 
a hyphen.

     4)  At the DEBUG prompt, type:

               R

then type the Enter key; the screen will now display something 
like:

AX=0000  BX=0002  CX=0E21  DX=0000  SP=FFEE  BP=0000  SI=0000  DI=0000
DS=23BE  ES=23BE  SS=23BE  CS=23BE  IP=0100   NV UP EI PL NZ NA PO NC
23BE:0100 4D            DEC     BP
^^^^

The portion you are interested in is the number in the far left 
of the bottom line.  Add 1000 to this number, that is, increase 
the leftmost digit by one.  In this case the calculation is:  
23BE + 1000 = 33BE.

     5)  At the DEBUG prompt, type:

               S XXXX:0  L FFFF 32 FF F9 C3

where XXXX is the number you calculated in step 4, then hit the 
Enter key.  In the above example you would use 33BE instead of 
XXXX.  This will return an address:

               YYYY:ZZZZ                         
     
     6)  At the DEBUG prompt again, use the segment address and 
offset that was just returned to give the DEBUG command:

               E YYYY:ZZZZ B7 02 
   
     The address that DEBUG returned in step 5 should be used in 
place of the address YYYY:ZZZZ, which we use as an example.  Hit 
the Enter key after the command; the DEBUG prompt should return 
in a moment.

     7)  At the DEBUG prompt, type:

               W

     Hit the Enter key; DEBUG will announce that it is writing a 
certain number of bytes, then it will return the DEBUG prompt.

     8)  At the DEBUG prompt, type:

               Q

     Hit the Enter key to exit DEBUG and return to DOS.

     9)   Rename X to DV.EXE:

               REN C:\DV\X C:\DV\DV.EXE

       --------------------------------------------------

     If the system fails after you perform this patch, copy the 
backup of DV.EXE that you made back to its original name.  

           COPY C:\DV\DVOLD.EXE C:\DV\DV.EXE

     (If your DV.EXE is not located in the DV  directory of the 
C: drive, change the path accordingly.)

     You may then wish to try the above procedure again, in case 
a mistake was made.

             * * *   E N D   O F   F I L E    * * *
